/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 1. 1B */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"

PtWidget_t *
my_inflate( PtWidget_t *window, 
	PtWidget_t *widget, 
	int position, 
	char *text, 
	char *font, 
	PgColor_t fill_color, 
	PgColor_t text_color )
{
	PtArg_t argt;
	char *balloon_text;

	PtSetArg( &argt, Pt_ARG_USER_DATA, &balloon_text, 0 );
	PtGetResources( widget, 1, &argt );

	// PtInflateBalloon returns a widget pointer to the inflated balloon. (using our new text :-)
	return PtInflateBalloon( window, widget, position, balloon_text, font, fill_color, text_color );

	// It is not required that PtInflateBalloon() be used.
	// you can create any kind of widget you like within this function and return the widget pointer.
	// 
	// "window" is the recommended parent so the balloon widget will be the frontmost widget in the
	//        application.
	// "widget" is the widget that the balloon is being inflated on behalf of.
	// "position" is a hint as to where the balloon widget should be positioned relative to "widget"
	//        See PtLabel's Pt_ARG_BALLOON_POSITIONING and PtLabel.h for possible values.
	// "text" is a pointer to a text string that would normally be used in the balloon.
	// "font" is the suggested font for the balloon.
	// "fill_color" is the suggested balloon fill color.
	// "text_color" is the suggested balloon text color.
}

int
balloon_override( PtWidget_t *link_instance, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{
	PtArg_t argt;
	PtWidget_t *wp;

	/* eliminate 'unreferenced' warnings */
	link_instance = link_instance, apinfo = apinfo, cbinfo = cbinfo;

	PtSetArg( &argt, Pt_ARG_LABEL_BALLOON, my_inflate, 0 );
	for( wp = PtWidgetChildBack( ABW_PtGroup1 ); wp; wp = PtWidgetBrotherInFront( wp ) )
		PtSetResources( wp, 1, &argt );
		
	return( Pt_CONTINUE );
}
